#!/bin/sh
#
#     Template SUSE system startup script for vmware-guest service/daemon
#     Copyright (C) 2008-2010  Dominique Leuenberger for openSUSE
#
#     This library is free software; you can redistribute it and/or modify it
#     under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation; either version 2.1 of the License, or (at
#     your option) any later version.
#
#     This library is distributed in the hope that it will be useful, but
#     WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#     USA.
#
# /etc/init.d/vmtoolsd
#
### BEGIN INIT INFO
# Provides:          vmtoolsd
# Required-Start:    $syslog $remote_fs
# Should-Start:
# Required-Stop:     $syslog $remote_fs
# Should-Stop:
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: VMWare Tools Daemon
# Description:       Starts the Tools Daemon for a VMWare Virtual Machine
### END INIT INFO

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
RETVAL=0
VMTOOLSD_BIN=/usr/bin/vmtoolsd
VMTOOLSUSER_BIN=/usr/bin/vmware-user
PIDFILE=/var/run/vmtoolsd.pid

prog="vmtoolsd"
lockfile=/var/lock/subsys/vmtoolsd
exec=$VMTOOLSD_BIN

test -x $VMTOOLSD_BIN || { echo "$VMTOOLSD_BIN not installed";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# The kernel module for the balloon driver changes its name in different kernel versions
#KERNEL_MICRO=$(uname -r | awk -F- '{print $1}' | sed 's,2.6.,,')
#case $KERNEL_MICRO in
#        27|28|29|30|31|32|33)
#                VMBALLOON=vmmemctl
#                ;;
#        34|35)
#                VMBALLOON=vmware_balloon
#                ;;
#        *)
#                VMBALLOON=vmw_balloon
#                ;;
#esac


. /etc/rc.d/init.d/functions

# Return values acc. to LSB for all commands but status:
# 0       - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
	echo -n "Starting vmtoolsd "
	if [ ! -d /tmp/VMwareDnD ]; then
	    mkdir -m 1777 /tmp/VMwareDnD
	fi
	#modprobe vmblock
	#mount -t vmblock none /proc/fs/vmblock/mountPoint
	#modprobe $VMBALLOON
	#modprobe vmsync
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	daemon $VMTOOLSD_BIN -b "$PIDFILE" -l
	RETVAL=$?
	echo
	[ $RETVAL = 0 ] && touch $lockfile
	;;
    stop)
	echo -n "Shutting down vmtoolsd "
	if [ -f "$VMTOOLSUSER_BIN" ]; then
	  killproc $VMTOOLSUSER_BIN -SIGUSR1
	fi
	killproc $prog -TERM
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && rm -f $lockfile
	#umount /proc/fs/vmblock/mountPoint || :
	#modprobe -r vmblock || :
	#modprobe -r vmsync || :
	#modprobe -r $VMBALLOON || :
	;;
    try-restart|condrestart)
	rhstatus >/dev/null 2>&1 || exit 0
	$0 restart
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start
	;;
    force-reload)
	$0 try-restart
	;;
    reload)
	echo -n $"Reloading $prog: "
	if [ -n "`pidfileofproc $exec`" ]; then
		killproc $exec -HUP
	else
		failure $"Reloading $prog"
	fi
	retval=$?
	echo
	;;
    status)
	status -p "$PIDFILE" -l $prog $exec
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart}"
	exit 1
	;;
esac
